// -*- coding:euc-jp -*-
#include "wimexim.h"
#include "lib/ut.h"
#include "so/wimeapi.h"
#include <X11/Xutil.h>

/*
  ic°FocusWindowѥɥĤ롣
  rootFocusWindowϻȤƤʤȤ֤פ
  icؤΥåȤFocusWindoϤ뤳Ȥ롣(16/1/10)
*/

extern char* DefaultCompFont;
extern Display* Disp;

static void init(CallbackParam* p)
{
    SetCompFont(p->Ic);
    WimeSetCompWin(p->Ic->WimeCxn,WIME_POS_POINT,0,0);

    int x=0,y=0,h=p->Ic->CompFontHeight,w=h*20;
    if(p->Ic->Attrs.FocusWindow == 0){
	//FocusWindowȤƤʤ褦ʤ롣
	p->Ic->Attrs.FocusWindow = XCreateSimpleWindow(Disp,XDefaultRootWindow(Disp),x,y,w,h,0,0,WhitePixel(Disp,XDefaultScreen(Disp)));
	p->Ic->Flags |= ICF_MAKE_FOCUSWIN;
    }
    p->Ic->Attrs.Defined |= FLG(IC_FOCUS_WINDOW);

    //Խ뤬ư줿ư
    XSelectInput(Disp,p->Ic->Attrs.FocusWindow,StructureNotifyMask);

    //ϼΤclientǹԤʤΤ,Խɥ˥եʤ褦ˤ 
    XWMHints *hints = XAllocWMHints(); //0ꥢ(hints->input=False)
    hints->flags = InputHint;
    XSetWMHints(Disp,p->Ic->Attrs.FocusWindow,hints);
    XFree(hints);
}

//StructureNotifyMask򥻥åȤɥ֤
static Window target_window(const IcData* ic)
{
    return ic->Attrs.FocusWindow;
}

//ư
static void move_wime(const IcData* ic,int x UNUSED,int y UNUSED)
{
    MoveWineWindow(ic);
    WimeSetCompWin(ic->WimeCxn,WIME_POS_POINT,0,0);
    WimeSetCandWin(ic->WimeCxn,WIME_POS_POINT,0,0);	//[r18]åȤΰ
}

static int open_ime(CallbackParam* p,bool st)
{
    WimeEnableIme(p->Ic->WimeCxn,st);

    if(st){
	XMapWindow(Disp,p->Ic->Attrs.FocusWindow);
    }else
	XUnmapWindow(Disp,p->Ic->Attrs.FocusWindow);
    return 0;
}

static void cleanup(CallbackParam* p)
{
    if(p->Ic->Flags & ICF_MAKE_FOCUSWIN){
	XDestroyWindow(Disp,p->Ic->Attrs.FocusWindow);
    }
}

static int done_preedit(CallbackParam* p UNUSED)
{
    return 0;
}

static bool reject_key(CallbackParam* p UNUSED)
{
    return true;
}

ConvCallbackFuncs ConvFuncRootInput = {
    .OpenIme =		open_ime,
    .Done =		done_preedit,
    .Draw =		ConvDoNothing,
    .RejectKey =	reject_key,
    .Cleanup =		cleanup,
    .SetSpotLoc =	ConvDoNothing,
    .Init =		init,
    .TargetWindow =	target_window,
    .MoveWime =		move_wime,
};

//(C) 2009 thomas
